// Copyright (c) 2015, Mikhail Stolyarov. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

library do2init.example;

import 'dart:async';
import 'package:do2init/do2init.dart';


class Module implements Do2Loader {

  String name;

  bool get isLoadWait => true;
  bool get isUnloadWait => true;

  Module(String this.name);

  void loading(Completer completer) {
    completer.complete('loading modul: $name');
  }

  void unloading(Completer completer) {
    completer.complete('unloading modul: $name');
  }

}

main() {
  Module mod1 = new Module('First');
  Module mod2 = new Module('Second');
  Module mod3 = new Module('Third');

  Future complete = Do2Init.loading([mod1, mod2], progress: (int value, int max, dynamic result) {
    print('Load:${value.toString()} max:${max.toString()} result:${result.toString()}');
  });
  complete.then((value) => print('load completed! result: ${value.toString()}'));
  complete.then((value) {

    Future complete2 = Do2Init.loading([mod1, mod2, mod3], progress: (int value, int max, dynamic result) {
      print('Load:${value.toString()} max:${max.toString()} result:${result.toString()}');
    });
    complete2.then((value) => print(value));

    complete2.then((value) => Do2Init.unloading([mod1, mod2, mod3], progress: (int value, int max, dynamic result) {
      print('Load:${value.toString()} max:${max.toString()} result:${result.toString()}');
    }).then((value) => print('Unload completed! result: ${value.toString()}')));
  });

}
